; GUI #
include win64a.inc
MUTEX_DATA_COUNT = 16
MUTEX_ALL_ACCESS = 1F0001h
size_of_buffer	 = 96
IDC_DIALOG	equ 200
ID_TXT		equ 100
ID_ICON		equ 102
ID_PROGRESS	equ 106
IDC_ICON1	equ 500
.code
WinMain proc
	enter	30h,0
	mov	r9d,offset DialogProc
	and	qword ptr[rbp-10h],0
        invoke  DialogBoxParam,IMAGE_BASE,IDC_DIALOG,HWND_DESKTOP
        invoke  RtlExitUserProcess,NULL
WinMain endp
DialogProc proc hWnddlg:qword,msg:qword,wParam:qword,lParam:qword
local	MutexName[256]:word

	mov	hWnddlg,rcx
	mov	lParam,r9

	cmp	edx,WM_INITDIALOG
	jne	wmBYE
wmINITDIALOG:mov hWnd,rcx
        mov 	edx,GWL_STYLE
	invoke	GetWindowLongPtr
    	or	eax,WS_THICKFRAME OR WS_MINIMIZEBOX OR WS_MAXIMIZEBOX
	mov	edx,GWL_STYLE
	invoke	SetWindowLongPtr,hWnddlg,,rax
	mov	r8d,offset WndProc
	mov	edx,GWL_WNDPROC
	invoke	SetWindowLongPtr,hWnddlg
;   
	mov	edx,offset szWin
        invoke  FindWindow,NULL
        or      eax,eax
        jnz	wmBYE
	mov	edx,offset Error1
	mov	r8d,offset szAppName
	invoke	MessageBox,hWnddlg,,,MB_ICONEXCLAMATION or MB_YESNO
	cmp	eax,IDNO
	jz      wmBYE
	mov	ecx,offset szService
	invoke	WinExec,,SW_SHOW
;------------------------------------
	xor	edi,edi
@@:	lea	ecx,MutexName
	mov	edx,offset fmtH
	invoke	wsprintf,,,edi
	lea	r8d,MutexName
	invoke	OpenMutex,MUTEX_ALL_ACCESS,FALSE
	mov	handlesH[rdi*8],rax

	lea	ecx,MutexName
	mov	edx,offset fmtL
	invoke	wsprintf,,,edi
	lea	r8d,MutexName
	invoke	OpenMutex,MUTEX_ALL_ACCESS,FALSE
	mov	handlesL[rdi*8],rax
	inc	edi
	cmp	edi,MUTEX_DATA_COUNT
	jb	@b
	mov	r8d,offset Format5
	invoke	OpenEvent,EVENT_ALL_ACCESS,0
	mov	hEventAck,rax	
	mov	r9d,offset EVENT_RECEIVER_READY
	invoke	CreateEvent,NULL, TRUE, FALSE
	mov	eventReceiverReady,rax
;-----------------------------------------------
;  
	pushaddr szFont	
	push	FIXED_PITCH+FF_DONTCARE
	push	PROOF_QUALITY
	push	CLIP_DEFAULT_PRECIS
	push	OUT_RASTER_PRECIS
	push	ANSI_CHARSET
	push	FALSE
	push	FALSE
	push	FALSE
	push	FW_BOLD
	sub	esp,20h
        invoke  CreateFont,32,12,0,0                
        mov     hFont,rax

        invoke  GetDlgItem,hWnddlg,ID_PROGRESS
        mov     hProgress,rax
;    
	mov	r8d,offset ProgressWindowProc
        invoke  SetWindowLongPtr,hProgress,GWL_WNDPROC
        ;    
        mov     OldProc,rax
wmBYE:	xor	eax,eax
	leave
	retn
DialogProc endp
WndProc proc hWnd:qword,msg:qword,wParam:qword,lParam:qword
local	SizeString:qword
local	text:dword
local	ps:PAINTSTRUCT                
local	hDC:dword
local	rcClient:RECT

	mov	hWnd,rcx
	mov	lParam,r9

        cmp	edx,WM_CLOSE
	je	wmCLOSE
	cmp	edx,WM_COMMAND
	je	wmCOMMAND
	cmp	edx,WM_DESTROY
	je	wmDESTROY
	cmp	edx,WM_USER+1
	je	wmUSER_1
	leave
	jmp	NtdllDialogWndProc_

wmUSER_1:mov	SizeString,r9
        xor	ecx,ecx
        and	percent,ecx
	mov	[rsp+20h],rcx
	movr	qword ptr[rsp+28h],hThread2
	mov	r8d,offset TimerFuncProgress
	invoke	CreateThread,,0,,1
	invoke	CloseHandle,eax
	movr	qword ptr[rsp+28h],threadId
	xor	ecx,ecx
	mov	[rsp+20h],rcx
	mov	r8d,offset ReceiverThreadTxt
	invoke	CreateThread,,0,,SizeString
	invoke	CloseHandle,eax
	jmp	wmBYE
wmDESTROY:invoke CloseHandle,eventReceiverReady
	xor	edi,edi
@@:	invoke	CloseHandle,handlesH[rdi*8]
	invoke	CloseHandle,handlesL[rdi*8]
	inc	edi
	cmp	edi,MUTEX_DATA_COUNT
	jb	@b
	jmp	wmBYE
wmCOMMAND:cmp	r8d,BN_CLICKED shl 16 + IDCANCEL
	jne	wmBYE
wmCLOSE:invoke	EndDialog,,0

wmBYE:	mov	eax,TRUE
exit0:	leave
	retn
WndProc endp

ReceiverThreadTxt proc SizeString:dword
local	index:byte
local	value:byte
local	buffer[256]:byte
	
	lea	edi,buffer
	add	ecx,edi
	mov	SizeString,ecx
	and	byte ptr[rdi],0
        invoke  SetDlgItemText,hWnd,ID_TXT,edi

	invoke	SetEvent,eventReceiverReady
@@:	mov	edx,offset handlesL
	invoke	WaitForMultipleObjects,MUTEX_DATA_COUNT,,FALSE,INFINITE
	mov	index,al
	invoke	ReleaseMutex,handlesL[rax*8]
        mov	edx,offset handlesH
	invoke	WaitForMultipleObjects,MUTEX_DATA_COUNT,,FALSE,INFINITE
	mov	value,al
	invoke	ReleaseMutex,handlesH[rax*8]
	mov	al,value
	shl	al,4
	or	al,index
;----------------------------------------------
	stosb
        invoke	SetEvent,hEventAck
	cmp	edi,SizeString
	jb	@b
;--------------------------------------------------
	lea	r8d,buffer
        invoke  SetDlgItemText,hWnd,ID_TXT
	invoke	ResetEvent,eventReceiverReady
	leave
	xor	eax,eax
	ret
ReceiverThreadTxt endp

TimerFuncProgress proc lParam:qword
	mov	lParam,rcx
;    
@@:	mov	r8d,percent
	mov	edx,offset szText
	mov	ecx,offset buff
        invoke  wsprintf
;    ProgressBar
	mov	r8d,offset buff
	mov	edx,offset szProp
        invoke  SetProp,hProgress
;     ProgressBar
	mov	r8d,percent
	mov	edx,offset szPerc
        invoke  SetProp,hProgress
;   
        invoke  InvalidateRect,hProgress,0,FALSE
        inc     percent
        cmp     percent,101
        je	exit0
	invoke	Sleep,lParam
	jmp	@b
exit0:	leave
	ret
TimerFuncProgress endp

ProgressWindowProc proc hEdit:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	text:dword
local	ps:PAINTSTRUCT                
local	hDC:dword
local	rcClient:RECT

	mov	hEdit,rcx
	mov	uMsg,rdx
	mov	wParam,r8
	mov	lParam,r9
	cmp	edx,WM_PAINT
	je	wmPAINT
	mov	[rsp+20h],r9;lParam
	mov	r9,wParam
	mov	r8,uMsg
	mov	rdx,hEdit
        invoke  CallWindowProc,OldProc
	jmp	wmBYE
wmPAINT:;  
        lea     edx,rcClient
        invoke  GetClientRect,hEdit;,edi
        ;    
	mov	edx,offset szProp
        invoke  GetProp,hEdit;hProgress
        mov     text,eax
;  
        lea     edx,ps
        invoke  BeginPaint,hEdit;hProgress
        mov     hDC,eax
; 
        invoke  SelectObject,hDC,hFont
        invoke  SetBkMode,hDC,TRANSPARENT
;   
        invoke  GetSysColorBrush,COLOR_WINDOW
        lea     edx,rcClient
        invoke  FillRect,hDC,,eax
;    ?
        cmp     text,0
        je      @f
        invoke  GetSysColor,COLOR_WINDOWTEXT
        invoke  SetTextColor,hDC,eax
	mov	edx,offset buff
	mov	qword ptr[rsp+20h],DT_NOPREFIX or DT_SINGLELINE or DT_VCENTER or DT_CENTER
        lea     r9d,rcClient
        invoke  DrawText,hDC,,-1                
@@:;     
	mov	edx,offset szPerc
        invoke  GetProp,hEdit;hProgress
        mov     ecx,eax
        lea     r9d,rcClient
        mov     eax,[r9].RECT.right
        sub     eax,[r9].RECT.left
        mul     ecx
        xor     edx,edx
        mov     ecx,100
        div     ecx
;   
        add     eax,[r9].RECT.left
;   
	mov	ecx,[r9].RECT.left
	mov	edx,[r9].RECT.top
	mov	r9d,[r9].RECT.bottom
        invoke  CreateRectRgn,,,eax
        invoke  SelectClipRgn,hDC,eax
        invoke  GetSysColorBrush,COLOR_HIGHLIGHT
	lea     edx,rcClient
        invoke  FillRect,hDC,,eax
;    ?
        cmp     text,0
        je      @f
        invoke  GetSysColor,COLOR_HIGHLIGHTTEXT
        invoke  SetTextColor,hDC,eax
	mov	qword ptr[rsp+20h],DT_NOPREFIX or DT_SINGLELINE or DT_VCENTER or DT_CENTER
	mov	edx,offset buff
        lea     r9d,rcClient
        invoke  DrawText,hDC,,-1
@@:	lea     edx,ps
        invoke  EndPaint,hDC
	xor	eax,eax
wmBYE:	leave
	ret
ProgressWindowProc endp
;-----------------------------------------------------------------------
.data
szWin		db "Mutex Sender",0
Error1		db "The server is not running.",10,"Run?",0
szAppName	db "Mutex Reciever",0
szService	db "09s",0
hWnd		dq ?
buff		db 100 dup(?)
szText  	db '%u%% completed',0
percent		dd 0
hProgress	dq ?
hFont		dq ?
szProp		db 'text',0
szPerc		db 'percent',0
szFont		db "Verdana",0
OldProc		dq ?
hThread2	dq ?
align 10h
eventReceiverReady dq ?
threadHandle	dq ?
threadId	dd ?
handlesH	dq 16 dup(?)
handlesL	dq 16 dup(?)
hEventAck	dq ?
fmtH		db "MtxDataH:%u",0
fmtL		db "MtxDataL:%u",0
Format5		db "Song_of_the_South_A",0
EVENT_RECEIVER_READY     db "EvReceiverReady",0
end 